'񂩂R̂ǂԂ
Public Class Form1

    Private Enum GameLevelType
        Low
        High
    End Enum

    Const Version As String = "V1.0.0"

    Const MaxNumber As Integer = 9
    Const MaxSuit As Integer = 4
    Const MaxCards As Integer = MaxNumber * MaxSuit
    Const MaxBa As Integer = 21

    Private sizeBox As Integer = 32
    Private sizeMrk As Integer = 16
    Private posBaX As Integer = 104
    Private posBaY As Integer = 8

    Private pctBa(MaxBa - 1) As PictureBox
    Private pctCards(MaxNumber) As PictureBox
    Private pctSel(MaxNumber) As PictureBox
    Private pctCsr(1) As PictureBox

    Private rnd As Random
    Private cardsAll(MaxCards - 1) As ClsCards
    Private noBackup(MaxCards - 1) As Integer

    Private gameLevel As GameLevelType
    Private selCount As Integer
    Private yamaPos As Integer

    Private timDelete As Integer

    Private frmWidth As Integer = 0
    Private frmHeight As Integer = 0

    Private Sub MenuItem2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem2.Click
        If MsgBox("I܂H", MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
            Timer1.Enabled = False
            Me.Close()
        End If
    End Sub

    Private Sub MenuItem3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem3.Click
        Timer1.Enabled = False
        MsgBox("񂩂R̂ǂԂ " & Version, MsgBoxStyle.Information)
        Timer1.Enabled = True
    End Sub

    Private Sub MenuItem6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem6.Click
        Me.NextGame(GameLevelType.High)
    End Sub

    Private Sub MenuItem7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem7.Click
        Me.NextGame(GameLevelType.Low)
    End Sub

    Private Sub NextGame(ByVal level As GameLevelType)
        If MsgBox("Vɒ킵܂H", MsgBoxStyle.YesNo Or MsgBoxStyle.Question) = MsgBoxResult.Yes Then
            Me.gameLevel = level
            TimStopDel()
            NewGame()
            DispGame()
            MakeTable()
            Me.DebugOut2("New Game")
        End If
    End Sub

    Private Sub MenuItem5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem5.Click
        If MsgBox("x킵܂H", MsgBoxStyle.YesNo Or MsgBoxStyle.Question) = MsgBoxResult.Yes Then
            TimStopDel()
            RetryGame()
            DispGame()
            MakeTable()
            Me.DebugOut2("Retry Game")
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        frmWidth = Me.Size.Width
        frmHeight = Me.Size.Height

        Dim i As Integer
        pctBa = New System.Windows.Forms.PictureBox() { _
            Me.pctBa01, Me.pctBa02, Me.pctBa03, Me.pctBa04, _
            Me.pctBa05, Me.pctBa06, Me.pctBa07, Me.pctBa08, _
            Me.pctBa09, Me.pctBa10, Me.pctBa11, Me.pctBa12, _
            Me.pctBa13, Me.pctBa14, Me.pctBa15, Me.pctBa16, _
            Me.pctBa17, Me.pctBa18, Me.pctBa19, Me.pctBa20, _
            Me.pctBa21, Me.pctYama1, Me.pctYama2 _
        }
        For i = 0 To pctBa.Length - 1
            Me.pctBa(i).Tag = i
        Next i
        pctCards = New System.Windows.Forms.PictureBox() { _
            Me.pctCard01, Me.pctCard02, Me.pctCard03, Me.pctCard04, _
            Me.pctCard05, Me.pctCard06, Me.pctCard07, Me.pctCard08, _
            Me.pctCard09, Me.pctCard10, Me.pctCard11 _
        }
        pctCsr = New System.Windows.Forms.PictureBox() { _
            Me.pctCursor1, Me.pctCursor2 _
        }
        For i = 0 To pctCsr.Length - 1
            Me.pctCsr(i).Tag = i
        Next i
        pctSel = New System.Windows.Forms.PictureBox() { _
            Me.pctSel01, Me.pctSel02, Me.pctSel03, Me.pctSel04, _
            Me.pctSel05, Me.pctSel06, Me.pctSel07, Me.pctSel08, _
            Me.pctSel09 _
        }
        For i = 0 To pctSel.Length - 1
            Me.pctSel(i).Tag = i
        Next i

        pctKeyCsr.Tag = 0

        For i = 0 To Me.cardsAll.Length - 1
            Me.cardsAll(i) = New ClsCards(Int(i / MaxNumber), i Mod MaxSuit)
        Next i

        Me.ResizeForm()

        Me.gameLevel = GameLevelType.High
        rnd = New Random
        NewGame()
        DispGame()
        MakeTable()

        TimStopDel()
        Timer1.Interval = 100
        Timer1.Enabled = True

    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        ResizeForm()
    End Sub

    Private Sub ResizeForm()
        Try
            If frmWidth = 0 Then Exit Sub

            Dim posX As Integer
            Dim posY As Integer
            Dim type As Integer
            Dim zoom As Integer
            Dim h As Integer = System.Windows.Forms.Screen.PrimaryScreen.Bounds.Height
            Dim w As Integer = System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width
            'Dim h As Integer = Me.Height
            'Dim w As Integer = Me.Width
            'w = 480
            If w <= 240 Then
                w = 240 : h = 320
                zoom = 1
                type = 0
            ElseIf w <= 320 Then
                w = 320 : h = 240
                zoom = 1
                type = 1
            ElseIf w <= 480 Then
                w = 480 : h = 640
                zoom = 2
                type = 0
            Else
                w = 640 : h = 480
                zoom = 2
                type = 1
            End If
            sizeBox = 32 * zoom
            posBaX = w / 2 - sizeBox
            posBaY = h / 2 - sizeBox * 3
            Me.Height = h
            Me.Width = w

            If frmWidth = w AndAlso frmHeight = h Then Exit Sub

            frmWidth = Me.Width
            frmHeight = Me.Height

            posX = posBaX
            posY = posBaY
            Dim no As Integer = 0
            For y As Integer = 0 To 5
                posX = posBaX - sizeBox * y / 2
                For x As Integer = 0 To y
                    pctBa(no).Width = sizeBox
                    pctBa(no).Height = sizeBox
                    pctBa(no).Location = _
                        New System.Drawing.Point(posX, posY)
                    posX += sizeBox
                    no += 1
                Next x
                posY += sizeBox * 2 / 3
            Next y

            posX = Me.pctBa01.Location.X + sizeBox * 3
            posY = Me.pctBa01.Location.Y
            pctYama1.Width = sizeBox
            pctYama1.Height = sizeBox
            pctYama1.Location = _
                New System.Drawing.Point(posX, posY)
            pctYama1.Tag = MaxBa
            posY += sizeBox
            pctYama2.Width = sizeBox
            pctYama2.Height = sizeBox
            pctYama2.Location = _
                New System.Drawing.Point(posX, posY)

            For i As Integer = 0 To 1
                pctCsr(i).Width = sizeBox
                pctCsr(i).Height = sizeBox
            Next i

            pctKeyCsr.Width = sizeBox / 4
            pctKeyCsr.Height = sizeBox / 4
            pctKeyCsr.Location = _
                New System.Drawing.Point( _
                    Me.pctYama2.Location.X, _
                    Me.pctYama2.Location.Y)

        Catch ex As Exception
            MsgBox("ResizeForm:" & ex.Message)
        End Try

    End Sub

    Private Sub NewGame()
        If cardsAll(0) Is Nothing Then
            MsgBox("error NewGame")
            Exit Sub
        End If
        Dim no As Integer = 0
        For i As Integer = 0 To MaxCards - 1
            Me.cardsAll(i).No = map(i).no
            Me.cardsAll(i).Index = i
            Me.cardsAll(i).Index1 = map(i).index1
            Me.cardsAll(i).Index2 = map(i).index2
            Me.cardsAll(i).State = ClsCards.stateCards.OMOTE
        Next i

        'shaffle
        If Me.gameLevel = GameLevelType.Low Then
            Me.ShaffleLow()
        Else
            Me.ShaffleHigh()
        End If

        For i As Integer = 0 To MaxCards - 1
            Me.noBackup(i) = Me.cardsAll(i).No
        Next i

        pctYama1.Tag = MaxBa
        selCount = 0
        yamaPos = pctBa.Length - 2
    End Sub

    Private Sub RetryGame()
        For i As Integer = 0 To MaxCards - 1
            Me.cardsAll(i).No = Me.noBackup(i)
            Me.cardsAll(i).Index1 = map(i).index1
            Me.cardsAll(i).Index2 = map(i).index2
            Me.cardsAll(i).State = ClsCards.stateCards.OMOTE
        Next i
        pctYama1.Tag = MaxBa
        selCount = 0
        yamaPos = pctBa.Length - 2
    End Sub

    Private Sub ShaffleHigh()
        For i As Integer = 0 To MaxCards - 1
            Dim idx As Integer = Rand1(MaxCards)
            If i <> idx Then
                Dim tmp As Integer = Me.cardsAll(i).No
                Me.cardsAll(i).No = Me.cardsAll(idx).No
                Me.cardsAll(idx).No = tmp
            End If
        Next i
    End Sub

    Private Sub ShaffleLow()
        Dim rndMax As Integer = MaxCards / 2
        For i As Integer = 0 To rndMax - 1
            Dim idx As Integer = Rand1(rndMax)
            If i <> idx Then
                Dim tmp As Integer = Me.cardsAll(i).No
                Me.cardsAll(i).No = Me.cardsAll(idx).No
                Me.cardsAll(idx).No = tmp
            End If
        Next i
        For i As Integer = rndMax To MaxCards - 1
            Dim idx As Integer = Rand1(rndMax) + rndMax
            If i <> idx Then
                Dim tmp As Integer = Me.cardsAll(i).No
                Me.cardsAll(i).No = Me.cardsAll(idx).No
                Me.cardsAll(idx).No = tmp
            End If
        Next i

        Me.CheckSafe()
    End Sub

    Private Sub SafeSwap(ByVal idx1 As Integer)
        Dim no As Integer = Me.cardsAll(idx1).No
        For idx2 As Integer = idx1 + 2 To MaxBa
            If no <> Me.cardsAll(idx2).No Then
                Me.cardsAll(idx1).No = Me.cardsAll(idx2).No
                Me.cardsAll(idx2).No = no
                Exit Sub
            End If
        Next idx2
    End Sub

    Private Function SafeShaffle(ByVal idx As Integer) As Boolean
        Dim chkNo As Integer = cardsAll(idx).No
        Dim idx1 As Integer = cardsAll(idx).Index1
        If idx1 >= 0 AndAlso _
           Me.cardsAll(idx1).No = chkNo Then
            Me.SafeSwap(idx1)
        End If
        Dim idx2 As Integer = cardsAll(idx).Index2
        If idx2 >= 0 AndAlso _
           Me.cardsAll(idx2).No = chkNo Then
            Me.SafeSwap(idx2)
        End If
    End Function

    Private Sub CheckSafe2()
        Dim safePosition() As Integer = New Integer() { _
            6, 10, 11, 15, 16, 17 _
        }
        For i As Integer = 0 To safePosition.Length - 1
            Dim idx As Integer = Rand1(safePosition.Length)
            If i <> idx Then
                Dim t As Integer = safePosition(i)
                safePosition(i) = safePosition(idx)
                safePosition(idx) = t
            End If
        Next i
        Dim base As Integer = MaxCards / 2
        For i As Integer = 0 To 2
            Dim no As Integer = cardsAll(safePosition(i)).No
            For j As Integer = MaxBa To MaxCards - 1
                Dim t As Integer = cardsAll(j).No
                If t = no Then
                    cardsAll(j).No = cardsAll(i + base).No
                    cardsAll(i + base).No = t
                End If
            Next j
        Next i
    End Sub

    Private Sub CheckSafe()
        For i As Integer = 0 To MaxBa - 7
            Me.SafeShaffle(i)
        Next i
        Me.CheckSafe2()
    End Sub

    Private Sub DispGame()
        If cardsAll(0) Is Nothing Then
            MsgBox("error DispGame")
            Exit Sub
        End If
        Try
            For idx As Integer = 0 To MaxBa - 1
                cardsAll(idx).State = ClsCards.stateCards.URA
                Me.pctBa(idx).Image = pctCards(9).Image
                Me.pctBa(idx).Visible = True
            Next idx
            cardsAll(MaxBa).State = ClsCards.stateCards.OMOTE
            Dim no As Integer = cardsAll(MaxBa).No
            Me.pctYama1.Image = pctCards(no).Image
            Me.pctYama1.Visible = True
            Me.pctYama2.Image = pctCards(9).Image
            Me.pctYama2.Visible = True
        Catch ex As Exception
            MsgBox("error DispGame:" & ex.Message)
        End Try
        Me.pctCursor1.Visible = False
        Me.pctCursor2.Visible = False
        Dim pos As Integer = pctKeyCsr.Tag
        pctKeyCsr.Tag = Me.CursorNext(pos)
        Me.SetKeyCursor()
    End Sub

    Private Sub MakeTable()
        For idx As Integer = 0 To MaxBa - 1
            If cardsAll(idx).State <> ClsCards.stateCards.NON Then
                If cardsAll(idx).Index1 = -1 AndAlso _
                   cardsAll(idx).Index2 = -1 Then
                    cardsAll(idx).State = ClsCards.stateCards.OMOTE
                    Dim no As Integer = cardsAll(idx).No
                    Me.pctBa(idx).Image = pctCards(no).Image
                Else
                    cardsAll(idx).State = ClsCards.stateCards.URA
                End If
            End If
        Next idx
    End Sub

    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown

        Dim pos As Integer = pctKeyCsr.Tag
        Select Case e.KeyCode
            Case Keys.Up, Keys.Left
                pos = Me.CursorBefore(pos)

            Case Keys.Down, Keys.Right
                pos = Me.CursorNext(pos)

            Case Keys.Enter, Keys.Space
                Select Case selCount
                    Case 1, 2
                        For i As Integer = 0 To selCount
                            Dim idx As Integer = pctCsr(i).Tag
                            If idx > MaxBa Then
                                idx = MaxBa
                            End If
                            If idx = pos Then
                                pctCursor_Click(Me.pctCsr(i), System.EventArgs.Empty)
                                Exit Sub
                            End If
                        Next i
                    Case Else
                        'nop
                End Select

                If pos = pctBa.Length - 1 Then  'RD
                    pctYama2_Click(Me.pctBa(pos), System.EventArgs.Empty)
                Else
                    pctBa_Click(Me.pctBa(pos), System.EventArgs.Empty)
                End If
                Exit Sub

            Case Else
                'nop
        End Select

        pctKeyCsr.Tag = pos
        Me.SetKeyCursor()

    End Sub

    Private Sub SetKeyCursor()
        Dim pos As Integer = pctKeyCsr.Tag
        pctKeyCsr.Location = New System.Drawing.Point( _
                            Me.pctBa(pos).Location.X, _
                            Me.pctBa(pos).Location.Y)
    End Sub

    Private Sub pctYama2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pctYama2.Click
        Dim pct As PictureBox = sender
        Dim idx2 As Integer = Me.YamaNext(Me.yamaPos)
        DebugOut2(yamaPos.ToString & " " & idx2.ToString)
        If idx2 = 0 Then
            pctYama2.Visible = False
            Me.yamaPos = MaxBa
        Else
            pctYama1.Image = Me.pctCards(Me.cardsAll(idx2).No).Image
            pctYama1.Tag = idx2
            Me.yamaPos = idx2
        End If
    End Sub

    Private Sub pctBa_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _
        pctBa01.Click, pctBa02.Click, pctBa03.Click, pctBa04.Click, _
        pctBa05.Click, pctBa06.Click, pctBa07.Click, pctBa08.Click, _
        pctBa09.Click, pctBa10.Click, pctBa11.Click, pctBa12.Click, _
        pctBa13.Click, pctBa14.Click, pctBa15.Click, pctBa16.Click, _
        pctBa17.Click, pctBa18.Click, pctBa19.Click, pctBa20.Click, _
        pctBa21.Click, pctYama1.Click

        Dim pct As PictureBox = sender
        Dim idx As Integer = pct.Tag
        Dim no As Integer = Me.cardsAll(idx).No
        DebugOut(no.ToString & Me.cardsAll(idx).Index1 & Me.cardsAll(idx).Index2)
        If Me.cardsAll(idx).State = ClsCards.stateCards.NON Then Exit Sub
        If Me.cardsAll(idx).Index1 <> -1 Then Exit Sub
        If Me.cardsAll(idx).Index2 <> -1 Then Exit Sub
        If selCount = 1 Then
            Dim c1 As Integer = pctCsr(0).Tag
            If no <> Me.cardsAll(c1).No Then
                DebugOut("J[hႢ܂")    'ToDo:bZ[Wɂ
                Exit Sub
            End If
        End If
        If selCount < 2 Then
            pctCsr(selCount).Image = pctSel(no).Image
            pctCsr(selCount).Location = New System.Drawing.Point( _
                                    pct.Location.X, _
                                    pct.Location.Y)
            pctCsr(selCount).Visible = True
            pctCsr(selCount).Tag = idx
            selCount += 1
            If selCount = 2 Then
                Dim c1 As Integer = pctCsr(0).Tag
                If no = cardsAll(c1).No Then
                    TimStartDel()
                End If
            End If
        End If

    End Sub

    Private Sub pctCursor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pctCursor1.Click, pctCursor2.Click
        Dim pct As PictureBox = sender
        If pct.Visible = False Then
            DebugOut("Unvisible Cursor")
            Exit Sub
        End If

        For i As Integer = 0 To 1
            pctCsr(i).Visible = False         'LZ
            pctCsr(i).Location = New System.Drawing.Point(0, 0)
        Next i
        TimStopDel()
        selCount = 0
        DebugOut(selCount.ToString)
    End Sub

    Private Sub TimStopDel()
        timDelete = 0
    End Sub

    Private Sub TimStartDel()
        timDelete = 500
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If timDelete <= 0 Then Exit Sub
        timDelete -= Timer1.Interval
        If timDelete > 0 Then Exit Sub

        Try
            Dim flagEnd As Boolean = False
            For i As Integer = 0 To 1
                pctCsr(i).Visible = False
                pctCsr(i).Location = New System.Drawing.Point(0, 0)
                Dim idx As Integer = pctCsr(i).Tag
                If idx = 0 Then
                    flagEnd = True
                End If
                If idx < MaxBa Then
                    DebugOut2("Ba")
                    Me.cardsAll(idx).State = ClsCards.stateCards.NON
                    pctBa(idx).Visible = False
                    Dim lu As Integer = map(idx).index3
                    If lu >= 0 Then
                        Me.cardsAll(lu).Index2 = -1
                    End If
                    Dim ru As Integer = map(idx).index4
                    If ru >= 0 Then
                        Me.cardsAll(ru).Index1 = -1
                    End If

                Else
                    DebugOut2("Yama")
                    Me.cardsAll(idx).State = ClsCards.stateCards.NON
                    Dim idx2 As Integer = Me.YamaBefore(Me.yamaPos)
                    If idx2 = 0 Then
                        Me.yamaPos = 0
                        pctYama2.Visible = False
                        pctYama1.Tag = MaxBa
                    Else
                        pctYama1.Image = Me.pctCards(Me.cardsAll(idx2).No).Image
                        pctYama1.Tag = idx2
                        Me.yamaPos = idx2
                    End If
                End If
            Next i
            MakeTable()
            Dim pos As Integer = pctKeyCsr.Tag
            pctKeyCsr.Tag = Me.CursorNext(pos)
            Me.SetKeyCursor()
            selCount = 0
            If flagEnd Then
                MsgBox("߂łƁ`NAł", MsgBoxStyle.OkOnly)
            End If

        Catch ex As Exception
            Me.DebugOut2("Timer1_Tick:" & ex.Message)
        End Try
    End Sub

    Private Function YamaNext(ByVal idx As Integer) As Integer
        If idx = 0 Then Return 0
        Dim nx As Integer = idx + 1
        For i As Integer = Me.pctBa.Length - 2 To Me.cardsAll.Length - 1
            If nx >= Me.cardsAll.Length Then
                nx = Me.pctBa.Length - 2
            End If
            If Me.cardsAll(nx).State <> ClsCards.stateCards.NON Then
                Return nx
            End If
            nx += 1
        Next i
        Return 0
    End Function

    Private Function YamaBefore(ByVal idx As Integer) As Integer
        If idx = 0 Then Return 0
        Dim nx As Integer = idx - 1
        For i As Integer = Me.pctBa.Length - 2 To Me.cardsAll.Length - 1
            If nx < Me.pctBa.Length - 2 Then
                nx = Me.cardsAll.Length - 1
            End If
            If Me.cardsAll(nx).State <> ClsCards.stateCards.NON Then
                Return nx
            End If
            nx -= 1
        Next i
        Return 0
    End Function

    Private Function CursorNext(ByVal idx As Integer) As Integer
        Dim nx As Integer = idx + 1
        For i As Integer = 0 To Me.pctBa.Length - 1
            If nx > Me.pctBa.Length - 1 Then
                nx = 0
            End If
            If Me.pctBa(nx).Visible Then
                If Me.cardsAll(nx).Index1 = -1 AndAlso _
                   Me.cardsAll(nx).Index2 = -1 Then
                    Return nx
                End If
            End If
            nx += 1
        Next i
        Return Me.pctBa.Length - 1
    End Function

    Private Function CursorBefore(ByVal idx As Integer) As Integer
        Dim nx As Integer = idx - 1
        For i As Integer = 0 To Me.pctBa.Length - 1
            If nx < 0 Then
                nx = Me.pctBa.Length - 1
            End If
            If Me.pctBa(nx).Visible Then
                If Me.cardsAll(nx).Index1 = -1 AndAlso _
                   Me.cardsAll(nx).Index2 = -1 Then
                    Return nx
                End If
            End If
            nx -= 1
        Next i
        Return Me.pctBa.Length - 1
    End Function

    Structure mapType
        Public index As Integer
        Public index1 As Integer    '
        Public index2 As Integer    'E
        Public index3 As Integer    '
        Public index4 As Integer    'E
        Public no As Integer        'J[h̎
        Public Sub New(ByVal idx As Integer, ByVal idx1 As Integer, ByVal idx2 As Integer, ByVal idx3 As Integer, ByVal idx4 As Integer, ByVal n As Integer)
            index = idx
            index1 = idx1
            index2 = idx2
            index3 = idx3
            index4 = idx4
            no = n
        End Sub
    End Structure

    Public map As mapType() = { _
        New mapType(0, 1, 2, -1, -1, 0), _
        New mapType(1, 3, 4, -1, 0, 1), _
        New mapType(2, 4, 5, 0, -1, 2), _
        New mapType(3, 6, 7, -1, 1, 3), _
        New mapType(4, 7, 8, 1, 2, 4), _
        New mapType(5, 8, 9, 2, -1, 5), _
        New mapType(6, 10, 11, -1, 3, 6), _
        New mapType(7, 11, 12, 3, 4, 7), _
        New mapType(8, 12, 13, 4, 5, 8), _
        New mapType(9, 13, 14, 5, -1, 0), _
        New mapType(10, 15, 16, -1, 6, 1), _
        New mapType(11, 16, 17, 6, 7, 2), _
        New mapType(12, 17, 18, 7, 8, 3), _
        New mapType(13, 18, 19, 8, 9, 4), _
        New mapType(14, 19, 20, 9, -1, 5), _
        New mapType(15, -1, -1, -1, 10, 6), _
        New mapType(16, -1, -1, 10, 11, 7), _
        New mapType(17, -1, -1, 11, 12, 8), _
        New mapType(18, -1, -1, 12, 13, 0), _
        New mapType(19, -1, -1, 13, 14, 1), _
        New mapType(20, -1, -1, 14, -1, 2), _
        New mapType(21, -1, -1, -1, 1, 3), _
        New mapType(22, -1, -1, 20, 1, 4), _
        New mapType(23, -1, -1, 20, 1, 5), _
        New mapType(24, -1, -1, 20, 1, 6), _
        New mapType(25, -1, -1, 20, 1, 7), _
        New mapType(26, -1, -1, 20, 1, 8), _
        New mapType(27, -1, -1, 20, 1, 0), _
        New mapType(28, -1, -1, 20, 1, 1), _
        New mapType(29, -1, -1, 20, 1, 2), _
        New mapType(30, -1, -1, 20, 1, 3), _
        New mapType(31, -1, -1, 20, 1, 4), _
        New mapType(32, -1, -1, 20, 1, 5), _
        New mapType(33, -1, -1, 20, 1, 6), _
        New mapType(34, -1, -1, 20, 1, 7), _
        New mapType(35, -1, -1, 20, 1, 8) _
    }

    Private Function Rand1(ByVal max As Integer) As Integer
        Return rnd.Next(max)
    End Function

    Private Sub DebugOut(ByVal str As String)
        'TextBox1.Text = ""
        'For i As Integer = 0 To MaxCards - 1
        '    TextBox1.Text &= Me.cardsAll(i).No.ToString & " "
        'Next i
    End Sub

    Private Sub DebugOut2(ByVal str As String)
        'TextBox1.Text &= vbCrLf & str
    End Sub

End Class
